setwd("~/Dropbox/Agriculture Weather/displays")

fips.usa <- read.csv("../posterior_distributions/fips_usa.csv")

compare.files <- c("corn_yield_in_bu_per_acre.csv", "barley_yield_in_bu_per_acre.csv", "cotton_yield_in_lb_per_acre.csv", "rice_yield_in_lb_per_acre.csv", "soybeans_yield_in_bu_per_acre.csv", "wheat_yield_in_bu_per_acre.csv")

crops.x.year <- matrix(0, nrow(fips.usa), 2010 - 1949 + 1)
for (compare.file in compare.files) {
    df <- read.csv(paste0("../../CWC databases/Agriculture/crops_yield/", compare.file))
    crops.x.year <- crops.x.year + (!is.na(df[,4:ncol(df)]) & df[,4:ncol(df)] > 0)
}

## Calculate sum(#crops^2) for each county
scores <- rowSums(crops.x.year^2)
bests <- data.frame()
while (nrow(bests) < 6) {
    nextbest <- fips.usa[scores == max(scores),][1,]
    nextbest$score <- max(scores)
    scores[fips.usa$State == nextbest$State] <- 0
    bests <- rbind(bests, nextbest)
}

get.crops <- function(FID) {
    crops <- c()
    for (compare.file in compare.files) {
        df <- read.csv(paste0("../../CWC databases/Agriculture/crops_yield/", compare.file))
        crops <- c(crops, sum(!is.na(df[df$cnty_FID == FID, 4:ncol(df)]) & df[df$cnty_FID == FID, 4:ncol(df)] > 0))
    }
    crops
}

get.crops(1711)
bests$notes[1] <- "All but barley"
get.crops(1610)
bests$notes[2] <- "All but soybeans"
get.crops(1856)
bests$notes[3] <- "All but barley"
get.crops(2464)
bests$notes[4] <- "All but barley"
get.crops(2421)
bests$notes[5] <- "All but barley"
get.crops(2005)
bests$notes[6] <- "All but rice"
