## What kinds of values should I put in to reproduce Ypredict?

setwd("~/Dropbox/Agriculture Weather/displays")

fips.usa <- read.csv("../fips_usa.csv")

crop <- "cotton"

ypred <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/Ypredict.txt"), sep=' ', header=F)
preds <- read.csv("../cropfiles/predictors-Cotton-combined.csv")

alpha <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/coeff_alpha.txt"), sep=' ', header=F)
beta1 <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/coeff_beta1.txt"), sep=' ', header=F)
beta2 <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/coeff_beta2.txt"), sep=' ', header=F)
beta3 <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/coeff_beta3.txt"), sep=' ', header=F)
beta4 <- read.delim(file.path("~/Dropbox/Agriculture Weather/usa_cropyield_model/Code_cotton_variance/coeff_beta4.txt"), sep=' ', header=F)

library(dplyr)
year <- 2009
preds2 <- fips.usa %>% left_join(preds[preds$year == year,], by=c('FIPS'='fips'))
results <- data.frame(fips=c(), yours=c(), mine=c())
for (ii in which(!is.na(preds2$logy))) {
    ypred2 <- mean(alpha[,ii] + beta1[,ii] * (year - 1948) + beta2[,ii] * preds2$wreq[ii] + beta3[,ii] * preds2$gdds[ii] + beta4[,ii] * preds2$kdds[ii])
    results <- rbind(results, data.frame(fips=preds2$FIPS[ii], yours=ypred[1, ii], mine=ypred2, known=preds2$logy[ii]))
}

plot(results$yours, results$mine, ylab="My estimate", xlab="Ypredict.txt value", main=paste("Comparison for", crop, "in year", year))
points(results$yours, results$known, col=2)
lines(c(0, 10), c(0, 10))

plot(results$mine, results$known, xlab="My estimate", ylab="Observed value", main=paste("Comparison for", crop, "in year", year))
lines(c(0, 10), c(0, 10))

ii = which(fips.usa$FIPS == 53009)
ypred2 <- mean(alpha[,ii] + beta1[,ii] * (year - 1948) + beta2[,ii] * preds2$wreq[ii] + beta3[,ii] * preds2$gdds[ii] + beta4[,ii] * preds2$kdds[ii])


## Improvement ideas:
## 1. If extrapolating and coeff in "wrong direction", set to 0
## Or should I impose everywhere?
## If I don't, I might get weird border effects...
## No, cannot justify except under extrapolation.
