setwd("~/Dropbox/Agriculture Weather/displays")

library(dplyr)

fips.usa <- read.csv("../fips_usa.csv")
crops <- c("Barley", "Corn", "Cotton", "Rice", "Soybeans", "Wheat")
predfiles <- c("predictors-Barley-combined.csv", "predictors-Maize-combined.csv", "predictors-Cotton-combined.csv", "predictors-Rice-combined.csv", "predictors-Soybeans-combined.csv", "wheat-combine.csv")

results <- data.frame()
for (cc in 1:length(crops)) {
    crop <- crops[cc]
    print(crop)

    df <- read.csv(file.path("~/Dropbox/Agriculture Weather/cropfiles", predfiles[cc]))
    if (crop == 'Wheat')
        df$year <- df$year + 2010

    results <- rbind(results, data.frame(Crop=crop, Observations=paste0("\\num{", sum(!is.na(df$logy)), "} county-years"),
                                         Counties=paste0("\\num{", length(unique(df$fips[!is.na(df$logy)])), "}"),
                                         `Year Span`=paste(min(df$year[!is.na(df$logy)]), max(df$year[!is.na(df$logy)]), sep=" - ")))
}

library(xtable)
print(xtable(results), include.rownames=F, sanitize.text.function=function(x) x)
