# Crop Yield Model using hierarchical Bayesian Estimation - partial pooling #

# Convergence Statistics and Posterior Fits #

# After reading the .RData file # 

# Rhat Summary #
rhat_summary = c(min(all_convergence[,1]),quantile(all_convergence[,1],c(0.01,0.1,0.25,0.5,0.75,0.9,0.99)),max(all_convergence[,1]),mean(all_convergence[,1]))
neff_summary = c(min(all_convergence[,2]),quantile(all_convergence[,2],c(0.01,0.1,0.25,0.5,0.75,0.9,0.99)),max(all_convergence[,2]),mean(all_convergence[,2]))

# libraries for running jags in parallel
library(runjags)
library(rjags)
library(R2jags)
library(MCMCpack)
library(parallel)
library(mcmcplots)
library(superdiag)
library(coda)

# libraries for maps
library(maps)
library(maptools)
library(RColorBrewer)
library(classInt)
library(rworldmap)
library(mapproj)

attach.jags(bayes.mod.fit)
dic = bayes.mod.fit$BUGSoutput$DIC
pD =  bayes.mod.fit$BUGSoutput$pD

round(rhat_summary,1)
round(neff_summary)
dic
pD

# rhat_check = all_convergence[,1]/1.1
# max_rhatcheck = max(rhat_check)
# max_rhatcheck
# 100*(length(which(rhat_check > 1))/nrow(all_convergence)) 
# 
# neff_check = all_convergence[,2]/100000
# min_neffcheck = min(neff_check)
# min_neffcheck
# 100*length(which(neff_check < 0.001))/nrow(all_convergence)



#------------------------------------------------------------#
