This directory contains the code for performing the spatial
optimizations. To function, the AWASH model should be downloaded from
https://github.com/AmericasWater/awash.git

Then place this directory as a subfolder of the `analysis` directory.

# Basic demonstration

## Optimization model (expected time: 6 minutes per assumption)

1. Copy the `optim-model` directory to the `analyses` directory in
   AWASH.
2. Copy the `.csv` files from the data repository `optim` subdirectory
   to the same directory.
3. Run the `optcrop.jl` script using Julia:
```
cd analyses/optim-model
julia optcrop.jl
```

4. Move the resulting files into a subdirectory named `results`:
```
mkdir results
mv max*.csv results
mv current*.csv results
```

4. Run the `display.R` script to generate figures.
```
Rscript display.R
```

This will produce optimization projections under the `results`
directory for each adaptation assumption. Each optimization will be represented with a map
produced by `display.R`.

# Full reproduction

The various scripts and their outputs can be run in the following
order:

 - actualcrops.R -> actualcrops.csv
 - agriculture.jl -> farmvalue-limited<-N>.csv

 - optcrop.jl -> currentprofits, currentyields, maxbayesian
 - futureyield.jl -> all20XX, max20XX

 - mv max*.csv results-mc; mv current*.csv results-mc; mv all20*.csv results-mc OR
   mv max*.csv results; mv current*.csv results; mv all20*.csv results

 - constrainopt.jl -> results-mc/constopt-*.csv, results/shadows.csv
 - display.R any time
 - changes.R
 - outputs.R
 - constraintopt-byprice2.jl

 - basics.R
 - assumptions.R
 - cropribbon.R -> figure 3
 - constopt-byprice.R
 - tempdists.R -> figure 2

 - farmvalue-display.R
